//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "LoopBtn"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//--------------------------------------------------------------------------- 
void __fastcall TForm1::FormCreate(TObject *Sender)
{
strcpy(PictureText1,LabelFox->Caption.c_str());	
LabelRabbitPos = LabelRabbit->Left;
LabelFoxPos = LabelFox->Left;
ImFoxH = ImageFox->Height;
ImFoxW = ImageFox->Width;
ImFoxT = ImageFox->Top;
ImFoxL = ImageFox->Left;
ReadmeOn = False;
ChangeReadmeState();
ScanContinue = False;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonExitClick(TObject *Sender)
{
Close();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonResetClick(TObject *Sender)
{
// sample 1:
LoopButton1->Stop();
LoopButton1->Reset();	
Reset1();
// sample 2:
LoopButton2->Stop();
LoopButton2->Reset();	
Reset2();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Reset1()  // sample 1
{
ImageRabbit->Left = 5;	
ImageRabbit->Visible = True;
ImageFox->Stretch = False;
ImageFox->Align = alNone;
ImageFox->Height = ImFoxH;  ImageFox->Width = ImFoxW;
ImageFox->Left = ImFoxL;    ImageFox->Top = ImFoxT;
LabelExcept->SendToBack();
LabelExcept->Visible = False;
LabelFox->Caption = PictureText1;
LabelFox->Left = LabelFoxPos;
LabelRabbit->Visible = True;
LabelRabbit->Left = LabelRabbitPos;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Reset2()  // sample 2
{
if (ScanContinue) ScanContinue = False;
Edit1->Text = "";  
Memo1->Lines->Clear();
}
//---------------------------------------------------------------------------
 
bool __fastcall TForm1::Meeting(int X)
{
return( (ImageRabbit->Left + ImageRabbit->Width - 3) > X );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoopButton1Click(TObject *Sender)
{
if (Meeting(ImageFox->Left)) {
  ImageRabbit->Visible = False;
  LabelFox->Left = Panel1->Left + (Panel1->Width - LabelFox->Width) / 2;
  LabelFox->Caption = "End of story, see step count on LoopButton";
  LabelExcept->BringToFront();
  LabelExcept->Visible = True;
  ImageFox->Stretch = True;
  ImageFox->Align = alClient;
  ImageFox->SendToBack();
  LabelRabbit->Visible = False;
  LoopButton1->Stop();
  }
else {
  ImageRabbit->Left += 20;
  LabelRabbit->Left += 20;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoopButton1IterEvent(TObject *Sender,
	TIterState IterState)
{
if (IterState 	== stLoopStart) Reset1();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoopButton2Click(TObject *Sender)
{
int Done;
char S[200];
if (ScanContinue) Done = findnext(&SearchRec);
else {
  GetWindowsDirectory(Path,200);
  if (Path[StrLen(Path)-1] != '\\') strcat(Path,"\\");
  strcpy(S,Path);
  strcat(S,"*.ini");
  Done = findfirst(S,&SearchRec,0);
  ScanContinue = True;
  }
if (! Done) {
  strcpy(S,Path);
  strcat(S,SearchRec.ff_name);
  Edit1->Text = S;
  Memo1->Lines->LoadFromFile(Edit1->Text);
  }
else {
  Edit1->Text = "";  
  Memo1->Lines->Clear();
  ScanContinue = False;
  LoopButton2->Stop();
  }  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoopButton2IterEvent(TObject *Sender,
	TIterState IterState)
{
if (IterState 	== stLoopStart) Reset2();	
}
//---------------------------------------------------------------------------


// -------- README --------------
void __fastcall TForm1::DrawLines(TColor Col)
{
Canvas->Pen->Color = Col;
Canvas->MoveTo(MemoReadme->Left,MemoReadme->Top);
Canvas->LineTo(LoopButton1->Left + LoopButton1->Width,LoopButton1->Top);
Canvas->MoveTo(MemoReadme->Left,MemoReadme->Top);
Canvas->LineTo(LoopButton2->Left + LoopButton2->Width,LoopButton2->Top);
}
//-------------------------------
void __fastcall TForm1::ChangeReadmeState()
{
if (ReadmeOn) {
  MemoReadme->Visible = True;
  BitBtnReadme->Caption = "Hide text";
  DrawLines(clRed);
  }
else {
  MemoReadme->Visible = False;
  BitBtnReadme->Caption = "Explain";
  DrawLines(Color); // i.e. Form->Color, clBtnFace
  }  
}
//-------------------------------
void __fastcall TForm1::BitBtnReadmeClick(TObject *Sender)
{
ReadmeOn = ! ReadmeOn;
ChangeReadmeState();	
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtnAboutClick(TObject *Sender)
{
AboutBox->ShowModal();	
}
//---------------------------------------------------------------------------
